  function cl_separ(S,wo,FIG,subfig)

% Boudaries of separate classes plot in case of two pattern
% values (R=2) and S classes
%
% Input variables
%   S	- number of classes
%   wo	- neural network weights
%   FIG, subfig - figure and subfigure name
 
  figure(FIG); subplot(subfig(1));

    v=axis; PVX=[v(1),v(2)];
    for q=1:S-1 		    % Line q definition
      for n=q+1:S
	PXO=[];
	PY=(sum(wo(q,:).^2)-sum(wo(n,:).^2)-2*PVX*diff(wo([n q],2)))/...
						 (2*diff(wo([n q],1)));
	hty=line(PVX,PY,'color','b','LineStyle',':','LineWidth',0.5);
	for m=1:S		    % Evaluation of intersection of boundaries
	  if m~=n & m~=q
	    PXO=[PXO (diff(wo([m,q],1))*(sum(wo(q,:).^2)-sum(wo(n,:).^2))...
                     -diff(wo([n,q],1))*(sum(wo(q,:).^2)-sum(wo(m,:).^2)))/...
		(2*(diff(wo([n,q],2))*diff(wo([m,q],1))...
                   -diff(wo([m,q],2))*diff(wo([n,q],1))))];
	  end
	end
	  PXO=PXO( PXO > v(1) & PXO < v(2) );
	  PXO=[v(1) PXO v(2)]; PXO=sort(PXO);
	  PYO=(sum(wo(q,:).^2)-sum(wo(n,:).^2)-2*PXO*diff(wo([n q],2)))/...
						     (2*diff(wo([n q],1)));

        if S>2
	  for i=2:length(PXO);	    % Boundary lines segmentation
	  L=[];
	    for m=1:S		    % Intersection classification
	      if m~=n & m~=q
		PX=(PXO(i-1)+PXO(i))/2;
		PY=(sum(wo(q,:).^2)-sum(wo(n,:).^2)-2*PX*diff(wo([n q],2)))/...
						       (2*diff(wo([n q],1)));

		L=[L dist(wo(q,:),[PY;PX]) < dist(wo(m,:),[PY;PX]) ];
	      end
	    end; 
            if ~isempty(L) & prod(L)>0
	       line(PXO(i-1:i),PYO(i-1:i),'color','k',...
					  'LineStyle','-','LineWidth',2);
	    end
	  end
	end
      end
    end
